<?php
session_start();
require_once('config.php');
require_once('dbutils.php');
require_once('locationfuncs.php');
require_once('externaldbfuncs.php');
require_once('activity.php');

$masterdb = new GenericSqliteTable("var/master.db","master");
$commentdb = new GenericSqliteTable("var/comments.db","comments");
$externaldb = new GenericSqliteTable("var/externaldb.db","external");

$id = $_GET['id'];
if(!isset($masterdb[$_GET['id']]))
	die("No such ID");

$record = $masterdb[$_GET['id']];
$comments = $commentdb[$_GET['id']];
$nameCol = GetConfigOption('nameCol');

//*****************
//Process Comment
//*****************

$captchaFailed = 0;
if(isset($_POST['comment']) and !GetConfigOption('readOnly'))
{
	if(GetConfigOption('enableCaptcha'))
	{	
	require_once('recaptcha-php-1.11/recaptchalib.php');
	$privatekey = GetConfigOption('recaptchaPrivate');
	$resp = recaptcha_check_answer ($privatekey,
	                       $_SERVER["REMOTE_ADDR"],
	                       $_POST["recaptcha_challenge_field"],
	                       $_POST["recaptcha_response_field"]);

	if (!$resp->is_valid) {
	  // What happens when the CAPTCHA was entered incorrectly
	  $captchaFailed = 1;
	}
	}

	if(!$captchaFailed)
	{
	//print_r($_POST);
	$newcom = array();
	$newcom['comment'] = substr($_POST['comment'],0,$maxchars);
	$newcom['nickname'] = substr($_POST['nickname'],0,$maxnickname);
	$newcom['timestamp'] = time();
	$newcom['license'] = "CC0";
	$newcom['karma'] = 1;
	$newcom['uuid'] = uniqid();
	//print_r($newcom);

	if(!isset($comments['comments']))
		$comments['comments'] = array();
	array_push($comments['comments'], $newcom);
	$commentdb[$_GET['id']] = $comments;

	AddActivityEvent($record[$nameCol]." Comment Added",$newcom['nickname']." added a comment for ".$record[$nameCol]." on ".htmlspecialchars(date("F j, Y, g:i a",$newcom['timestamp'])),$newcom['nickname'],"details.php?id=".$_GET['id'],$newcom['uuid']);	
	}
}


//**************
//Process Vote
//**************

if(isset($_POST['vote']) and !GetConfigOption('readOnly'))
{
	if(GetConfigOption('enableCaptcha'))
	{	
	require_once('recaptcha-php-1.11/recaptchalib.php');
	$privatekey = GetConfigOption('recaptchaPrivate');
	$resp = recaptcha_check_answer ($privatekey,
	                       $_SERVER["REMOTE_ADDR"],
	                       $_POST["recaptcha_challenge_field"],
	                       $_POST["recaptcha_response_field"]);

	if (!$resp->is_valid) {
	  // What happens when the CAPTCHA was entered incorrectly
	  $captchaFailed = 1;
	}
	}

	if(!$captchaFailed)
	{
		//Prevent vote stuffing
		if($_POST['vote']>0) $_POST['vote'] = 1;
		if($_POST['vote']<0) $_POST['vote'] = -1;
		//echo $_POST['id'].",".$_POST['uuid'].",".$_POST['vote']."\n";
		
		ChangeKarmaLocationPosts($_GET['id'],$_POST['uuid'],$_POST['vote']);
		ChangeKarmaCommentPosts($_GET['id'],$_POST['uuid'],$_POST['vote']);
		ChangeKarmaExternalDbPosts($_GET['id'],$_POST['uuid'],$_POST['vote']);

		$voteDirection = "up";
		if($_POST['vote'] < 0) $voteDirection = "down";
		AddActivityEvent($record[$nameCol]." entry voted ".$voteDirection,$_POST['nickname']." voted ".$voteDirection." an entry for ".$record[$nameCol]." on ".htmlspecialchars(date("F j, Y, g:i a",time())),$_POST['nickname'],"details.php?id=".$_GET['id'],$_POST['uuid']);
	}
}

?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">
<!--
Design by Free CSS Templates
http://www.freecsstemplates.org
Released for free under a Creative Commons Attribution 2.5 License

Name       : Tomatoes
Description: A two-column, fixed-width design for 1024x768 screen resolutions.
Version    : 1.0
Released   : 20110301

-->
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="content-type" content="text/html; charset=utf-8" />
<title><?php echo GetConfigOption('overallTitle').", ".GetConfigOption('subTitle').", ".$record[$nameCol];?></title>
<meta name="keywords" content="" />
<meta name="description" content="" />
<link href="style.css" rel="stylesheet" type="text/css" media="screen" />
<link href="atomfeed.php" type="application/atom+xml" rel="alternate" title="Sitewide ATOM Feed" />
</head>
<body>
<div id="wrapper">
	<div id="header">
		<div id="menu">
			<ul>
				<?php $pageCatExplore = 1;
				require('topbar.php'); ?>
			</ul>
		</div>
		<!-- end #menu -->
	</div>
	<div id="logo">
		<h1><a href="#"><?php echo GetConfigOption('overallTitle');?></a></h1>
		<p><em><?php echo GetConfigOption('subTitle');?></em></p>
	</div>
	<hr />
	<!-- end #logo -->
	<div id="page">
		<div id="page-bgtop">
			<div id="content">

<?php if($captchaFailed) { ?>
				<div class="post">
					<h2 class="title"><a href="#">Captcha Problem</a></h2>
					<p class="meta"></p>
					<div class="entry">
						<p>There was a problem with the anti-spam test. Please try again.</p>
					</div>
				</div>
<?php } ?>

				<div class="post">
					<h2 class="title"><a href="#"><?php echo htmlspecialchars($record[$nameCol]); ?></a></h2>
					<p class="meta"></p>
					<div class="entry">

<?php
$bestLoc = GetBestLocation($id);
if($bestLoc[0] !== null)
	echo "<p>".GenerateViewHtml($bestLoc[0][0],$bestLoc[0][1],htmlspecialchars($record[$nameCol]))."</p>";

if(!GetConfigOption('readOnly'))
{
//********************
//Show list of actions
//********************
?>
<h3>Actions</h3>
<?php 
$firefoxWinLin = (strpos($_SERVER['HTTP_USER_AGENT'],"Firefox")!==FALSE and (strpos($_SERVER['HTTP_USER_AGENT'],"Linux")!==FALSE or strpos($_SERVER['HTTP_USER_AGENT'],"Windows")!==FALSE));?>
<p>Improve positional accuracy: <a href="gpsposition.php?id=<?php echo $_GET['id'];?>">Add GPS Position</a>, Mark on: <a href="markposition.php?basemap=sv&amp;id=<?php echo $_GET['id'];?>" accesskey="m">OS Map</a>, <a href="markposition.php?basemap=osm&amp;id=<?php echo $_GET['id'];?>" accesskey="o">OpenStreetMap</a>, <a href="markposition.php?basemap=os7&amp;id=<?php echo $_GET['id'];?>" accesskey="7">7th Series OS</a>, <a href="markposition.php?basemap=npe&amp;id=<?php echo $_GET['id'];?>" accesskey="n">New Popular Edition OS</a></p>
<p>Link to external database: <a href="externaldb.php?id=<?php echo $_GET['id'];?>">Known OpenStreetMap Object</a>, <a href="nearby.php?id=<?php echo $_GET['id'];?>" accesskey="s">Search OSM for Nearby Objects</a> <?php if($firefoxWinLin) echo"(Alt-shift-S)"; else echo "(<a href='http://en.wikipedia.org/wiki/Access_key'>Access key</a> S)";?></p>
<?php if(isset($_SESSION['username']) and $_SESSION['username'] == "admin")
{
?>
<p><a href="recordedit.php?id=<?php echo $_GET['id'];?>">Edit</a></p>
<?php
}
}
//********************
//Show original record
//********************
?>
<h3>Record</h3>
<ul>
<?php
foreach ($record as $col => $val)
{
	echo "<li>".htmlspecialchars($col).": ".htmlspecialchars($val)."</li>\n";
}

?>
</ul>


					</div>
				</div>


<?php
//*************************
//Show previous annotations
//*************************

function GetCommentPosts($id)
{
	global $commentdb;
	$comments = $commentdb[$id];

	$annots = array();
	if(isset($comments['comments']))
	foreach ($comments['comments'] as $com)
	{
		//print_r($loc);
		$n = array();
		$n['title'] = "Comment";
		$n['nickname'] = $com['nickname'];
		$n['timestamp'] = $com['timestamp'];
		$n['karma'] = $com['karma'];
		$n['uuid'] = $com['uuid'];
		$body = "<p>".htmlspecialchars($com['comment'])."</p>";		
		$n['body'] = $body;

		array_push($annots,$n);
	}
	return $annots;
}

function ChangeKarmaCommentPosts($id,$uuid,$vote)
{
	global $commentdb;
	$comments = $commentdb[$id];

	if(isset($comments['comments']))
	foreach ($comments['comments'] as $index => $com)
	{
		if($com['uuid'] != $uuid) continue;
		$comments['comments'][$index]['karma'] += (int)$vote;
		$commentdb[$id] = $comments;
	}

}

$locAnnots = GetLocationPosts($_GET['id']);
$comAnnots = GetCommentPosts($_GET['id']);
$extAnnots = GetExternalDbPosts($_GET['id']);
$allAnnots = array_merge($locAnnots,$comAnnots, $extAnnots);

//Sort by time
$postTimes = array();
foreach($allAnnots as $ann)
{
	array_push($postTimes,$ann['timestamp']);
}
array_multisort($postTimes,$allAnnots);

foreach($allAnnots as $anot)
{
?>
				<div class="post">
					<h2 class="title"><a href="#"><?php echo $anot['title']; ?></a></h2>
					<p class="meta"><?php echo htmlspecialchars(date("F j, Y, g:i a",$anot['timestamp'])); ?>
					<span>Posted by <a href="#"><?php echo htmlspecialchars($anot['nickname']); ?></a></span><span class="voting"><span class="<?php if($anot['karma']>=0) echo "goodkarma"; else echo "badkarma";?>"><?php echo $anot['karma']; ?></span>
<?php if (!GetConfigOption('readOnly')) { ?>
<a href="vote.php?id=<?php echo $_GET['id'];?>&amp;uuid=<?php echo $anot['uuid']; ?>&amp;vote=1"><img src="img/thumbsup.png" alt="Vote up"></a><a href="vote.php?id=<?php echo $_GET['id'];?>&amp;uuid=<?php echo $anot['uuid']; ?>&amp;vote=-1"><img src="img/thumbsdown.png" alt="Vote down"></a>
<?php } ?>
					</span>
					</p>
					<div class="entry">
						<?php echo $anot['body']; ?>
					</div>
				</div>
<?php
}

//*****************
//Comment Form
//*****************
if(isset($_POST['nickname'])) $_SESSION['nickname'] = $_POST['nickname'];
if(!isset($_SESSION['nickname'])) $_SESSION['nickname'] = "Anonymous";
$initialText = "Type your comment here.";
if(isset($_POST['comment'])) $initialText = $_POST['comment'];

if(!GetConfigOption('readOnly'))
{
?>
				<div class="post">
					<h2 class="title"><a href="#">Add A Comment for <?php echo htmlspecialchars($record[$nameCol]); ?></a></h2>
					<div class="entry">


<form method="post" action="">
<p>Your nickname: <input type="text" name="nickname" value="<?php echo htmlspecialchars($_SESSION['nickname']); ?>"/></p>
<p><textarea rows="10" cols="80" name="comment" ><?php echo htmlspecialchars($initialText);?></textarea></p>
<p>Maximum characters: <?php echo $maxchars; ?>. No HTML. You agree to waive any copyright, database right, and any other rights that may be waived, over submitted information, as specified in the <a href="http://creativecommons.org/choose/zero/">CC0 license</a>. This enables others to use your knowledge in innovative ways.</p> 
<?php
if(GetConfigOption('enableCaptcha'))
{
	require_once('recaptcha-php-1.11/recaptchalib.php');
	$publickey = GetConfigOption('recaptchaPublic');
	echo recaptcha_get_html($publickey);
}
?>
<p><input type="submit" value="Submit" /></p>
<p>You agree to waive any copyright, database right, and any other rights that may be waived, over submitted information, as specified in the <a href="http://creativecommons.org/choose/zero/">CC0 license</a>. This enables others to use your knowledge in innovative ways.</p>
</form>
					</div>
				</div>
<?php
} //End of comment form
?>
			</div>
			<!-- end #content -->
			<div id="sidebar">
				<ul>
					<?php require('sidebar.php'); ?>

				</ul>
			</div>
			<!-- end #sidebar -->
			<div style="clear: both;">&nbsp;</div>
		</div>
	</div>
	<!-- end #page -->
	<div id="footer">

<?php
	require_once('footer.php');
?>
	</div>
	<!-- end #footer -->
</div>
</body>
</html>
