<?php header('Content-Type: text/xml, charset=utf-8');
echo'<?xml version="1.0"?>'."\n";?>
<xml version="1.0" creator="ServiceLocatorPHP">
<?php

require_once('config.php');
require_once('dbutils.php');
require_once('locationfuncs.php');
require_once('externaldbfuncs.php');

$masterdb = new GenericSqliteTable("var/master.db","master");
$ids = $masterdb->GetKeys();
$commentsdb = new GenericSqliteTable("var/comments.db","comments");
$externaldb = new GenericSqliteTable("var/externaldb.db","external");
$locationsdb = new GenericSqliteTable("var/locations.db","locations");
$nameCol = GetConfigOption('nameCol');

echo "<master>\n";
foreach($ids as $id)
{
	echo "<record id=\"".htmlspecialchars($id)."\">\n";
	$record = $masterdb[$id];
	foreach($record as $field => $val)
	{
		echo "<data key=\"".htmlspecialchars($field)."\" val=\"".htmlspecialchars($val)."\" />\n";
	}
	echo "</record>\n";
}
echo "</master>\n";

echo "<comments>\n";
foreach($ids as $id)
{
	echo "<record id=\"".htmlspecialchars($id)."\">\n";
	$comments = $commentsdb[$id];
	if(isset($comments['comments']))
	foreach($comments['comments'] as $comment)
	{
		//echo "<data key=\"".htmlspecialchars($field)."\" val=\"".htmlspecialchars($val)."\" />\n";
		echo "<comment>\n";
		foreach($comment as $field => $val)
		{
			echo "<data key=\"".htmlspecialchars($field)."\" val=\"".htmlspecialchars($val)."\" />\n";
		}
		echo "</comment>\n";
	}
	echo "</record>\n";
}
echo "</comments>\n";

echo "<locations>\n";
foreach($ids as $id)
{
	echo "<record id=\"".htmlspecialchars($id)."\">\n";
	$locations = $locationsdb[$id];
	if(isset($locations['locations']))
	foreach($locations['locations'] as $location)
	{
		echo "<location>\n";
		foreach($location as $field => $val)
		{
			echo "<data key=\"".htmlspecialchars($field)."\" val=\"".htmlspecialchars($val)."\" />\n";
		}
		echo "</location>\n";
	}
	echo "</record>\n";
}
echo "</locations>\n";

echo "<external>\n";
foreach($ids as $id)
{
	echo "<record id=\"".htmlspecialchars($id)."\">\n";
	$externals = $externaldb[$id];
	if(isset($externals['external']))
	foreach($externals['external'] as $ext)
	{
		echo "<external>\n";
		foreach($ext as $field => $val)
		{
			echo "<data key=\"".htmlspecialchars($field)."\" val=\"".htmlspecialchars($val)."\" />\n";
		}
		echo "</external>\n";
	}
	echo "</record>\n";
}
echo "</external>\n";
$footerDone = 1;
?>
</xml>

